{{- define "main" -}}
<section class="w-full pb-2 border-b" style="overflow:hidden;">
<h1>Guide de styles</h1>
<h2 id="Colors" class="colortitle hide">Colors</h2>
<div class="primary hide">
<h3>Primary</h3>
<ul class="colors"></ul>
</div>
<div class="secondary hide">
<h3>Secondary</h3>
<ul class="colors"></ul>
</div>
<div class="tertiary hide">
<h3>Tertiary</h3>
<ul class="colors"></ul>
</div>
<div class="grey hide">
<h3>Grey</h3>
<ul class="colors"></ul>
</div>

<br><br>
<hr>

<h2 id="Typography">Typography</h2>

<h1>Heading 1</h1>
<h2>Heading 2</h2>
<h3>Heading 3</h3>
<h4>Heading 4</h4>
<h5>Heading 5</h5>
<h6>Heading 6</h6>
<p>This is a paragraph. The font family is monospace and for the headings 1 to 3 it’s Sans-Serif</a>.
  <b>Some bold text.</b>
  <i>Italics also looks nice.</i> You can <u>underline</u> things you feel are important. has
  styles that override the default heading styles, including margin.
</p>


<h2 id="codeBlock">Code Block</h2>
<p>
  <code>inline code;</code>
  <samp>inline samp;</samp> and kbd: <kbd>ctrl</kbd>
  <kbd>c</kbd>
</p>
<p>Code blocks are code tags wrapped with pre tags. They automatically overflow to become scrollable on smaller displays
</p>
<pre><code>&lt;pre&gt;&lt;code&gt;
&lt;h2&gt;Code Block Example&lt;/h2&gt;
&lt;/code&gt;&lt;/pre&gt;</code></pre>
<p>Samp blocks are similar but intended for output moslty so mono/color sets the line-height tighter to show it better
  (for example, ASCII art)
</p>
<pre><samp>                /\  (hi i’m v dude)
   __  ____  __/\/\__  __   ___
  /  \/ __ \ \ _  _ / /  \ |   \
 / /\ \__ \ \/\'  '/\/ /\ \|    |
/_/  \____/\__/\__/\__/  \_____/</samp></pre>

<pre><code>1---5---10---15---20---25---30---35---40---45---50---55---60---65---70---75---80---85---90---95--100--105--110--115--120--125--130--135--140--145--150--155--160--165--170--175--180--185--190--195--200--205--210--215--220--225--230--235--240--245--250--255--260--265--270--275--280--285--290--295--300
2
3
4
5
6
7
8</code>
</pre>

{{ partialCached "utils/css.html" (dict "context" . "filefolder" "elements" "filename" "codeformatting") "codeformatting" }}
<h2 id="Blockquote">Blockquote</h2>
<blockquote>
  You’re <em>not</em> a fucking moron if you use default browser styles you can do what ever the fuck you want
  who cares
  <br><cite>&mdash; Eleanor Roosevelt</cite>
  <blockquote>
    This is a nested quote
    <br><cite>&mdash; Me</cite>
    <blockquote>Yes, I totally took that from <a href="http://bettermotherfuckingwebsite.com/">this site</a>. I always
      used it as a reference.
      <br><cite>&mdash; Also me</cite>
    </blockquote>
  </blockquote>
</blockquote>
<br>
<h2 id="Lists">Lists</h2>
<p>Lists are default HTML lists. I tried a few things but figured the defaults are all that’s needed (imo).</p>
<h3>Unordered List</h3>
<ul>
  <li>First Item</li>
  <li>
    Second Item
    <ul>
      <li>Sub Item 1</li>
      <li>Sub Item 2</li>
    </ul>
  </li>
  <li>Third Item</li>
</ul>
<h3>Ordered List</h3>
<ol>
  <li>First Item</li>
  <li>
    Second Item
    <ol>
      <li>Sub Item 1</li>
      <li>Sub Item 2</li>
    </ol>
  </li>
  <li>Third Item</li>
</ol>
<h2 id="Tables">Tables</h2>
<p>Tables looks nice too:</p>
<table>
  <thead>
    <th>Name</th>
    <th>Username</th>
    <th>email</th>
    <th>secondary email</th>
  </thead>
  <tbody>
    <tr>
      <td>Lorem Ipsum</td>
      <td>lorem</td>
      <td>email@example.com</td>
      <td>email@example.org</td>
    </tr>
    <tr>
      <td>Lorem Ipsum</td>
      <td>lorem</td>
      <td>email@example.com</td>
      <td>email@example.org</td>
    </tr>
  </tbody>
</table>
<h2 id="Forms">Forms</h2>

{{ partialCached "utils/css.html" (dict "context" . "filefolder" "objects/" "filename" "form") "form" }}
<form class="tacenter">
<fieldset>
    <legend>Legend</legend>
    <label>Email <span class="form__required">requis</span></label>
    <input type="email" placeholder="ex. Tom Glance" required>
    <label>Password <span class="form__required">requis</span></label>
    <input type="password" placeholder="ex.tom.glance@mail.net" required>

  <label>Message</label>
  <textarea placeholder="Some information here" class="w-100"></textarea>
  <input type="submit" value="Submit" class="btn">
</fieldset>
</form>

<h2 id="Buttons">Buttons</h2>
<p>Buttons are created with either a button or an anchor, they both must have the <code>btn</code> class.</p>
<div>
  <a class="btn" href="#">Link button</a>
  <a class="btn skip" href="#">Skip button</a>
  <button class="btn">Regular Button</button>
  <p>Primary buttons are made with the <code>primary</code> class</p>
  <button class="btn btn--primary">Primary Button</button>
  <button class="btn btn--secondary">Secondary Button</button>
  <button class="btn btn--outline">Outline Button</button>
  <button class="btn warning">Warning Button</button>
  <button class="btn action">Action Button</button>
  <button class="btn" disabled>Disabled Button</button>
</div>

{{ partialCached "utils/css.html" (dict "context" . "filefolder" "objects" "filename" "card") "card" }}
<h2 id="Grid">Grid</h2>
<div class="grid">
  <div class="card card-border text-center">1</div>
  <div class="card card-border text-center">2</div>
</div>

<div class="grid">
  <div class="card card-border text-center">1</div>
  <div class="card card-border text-center">2</div>
  <div class="card card-border text-center">3</div>
</div>

<div class="grid">
  <div class="card card-border text-center">1</div>
  <div class="card card-border text-center">2</div>
  <div class="card card-border text-center">3</div>
  <div class="card card-border text-center">4</div>
</div>

<h2 id="grid">Flex</h2>
<div class="flex flex-gap">
  <div class="card card-border mb-2 text-center">1</div>
  <div class="card card-border mb-2 text-center">2</div>
</div>

<div class="flex flex-gap">
  <div class="card card-border mb-2 text-center">1</div>
  <div class="card card-border mb-2 text-center">2</div>
  <div class="card card-border mb-2 text-center">3</div>
</div>

<div class="flex flex-gap">
  <div class="card card-border mb-2 text-center">1</div>
  <div class="card card-border mb-2 text-center">2</div>
  <div class="card card-border mb-2 text-center">3</div>
  <div class="card card-border mb-2 text-center">4</div>
</div>


</section>
<aside id="widgets" class="widgets print:hidden">
<div id="acces-directs" class="pl-2 pr-2">
	<h2 class="flex-between">
    <span>Accès rapides</span>
  </h2>
	<ul role="list" class="grid grid-link">
    <li class="page-link | flex items-center enlarge-link page-link-width | hover-grey">
      <a href="#Colors">Colors</a>
    </li>
    <li class="page-link | flex items-center enlarge-link page-link-width | hover-grey">
        <a href="#Typography">Typography</a>
    </li>
    <li class="page-link | flex items-center enlarge-link page-link-width | hover-grey">
        <a href="#codeBlock">Code Block</a>
    </li>
    <li class="page-link | flex items-center enlarge-link page-link-width | hover-grey">
        <a href="#Blockquote">Blockquote</a>
    </li>
    <li class="page-link | flex items-center enlarge-link page-link-width | hover-grey">
        <a href="#Lists">Lists</a>
    </li>
    <li class="page-link | flex items-center enlarge-link page-link-width | hover-grey">
        <a href="#Tables">Tables</a>
    </li>
    <li class="page-link | flex items-center enlarge-link page-link-width | hover-grey">
        <a href="#Forms">Forms</a>
    </li>
    <li class="page-link | flex items-center enlarge-link page-link-width | hover-grey">
        <a href="#Buttons">Buttons</a>
    </li>
    <li class="page-link | flex items-center enlarge-link page-link-width | hover-grey">
        <a href="#Grid">Grid</a>
    </li>
	</ul>
</div>
</aside>
{{- end -}}
{{- define "script" -}}
<style>

table {
    border: solid 1px var(--color-grey-light);
    border-collapse: collapse;
    border-spacing: 0;
}
thead th {
    background-color: #dedede;
    border: solid 1px #dedede;
    color: #333;
    padding: calc(var(--baseline) / 2);
    text-align: left;
}
tbody td {
    border: solid 1px #dedede;
    color: var(--text-color);
    padding: 10px;
}

.card {
  min-height: 10rem;
  border: 1px solid grey;
  align-content: center;
}

ul ::marker,
ol ::marker {
  color: var(--color-primary-light, #000);
}

ol {
  list-style: none;
  counter-reset: counter;
}
ol li {
  counter-increment: counter;
}
ol li::before {
  content: counter(counter) ". ";
  color: var(--link-color, #000);
  font-weight: bold;
}


.colors {
  display: grid;
  grid-gap: 1.5rem;
  grid-template-columns: repeat(auto-fit, minmax(180px, 1fr));
  list-style: none;
  margin: 0;
  padding: 0;
}

.color {
  border-radius: 2px;
  border: 1px solid var(--text-color);
  transition: box-shadow 0.15s;
}

.color__swatch {
  background-color: var(--color);
  border-radius: 2px 2px 0 0;
  display: block;
  height: 120px;
}

.color__details {
  font-size: 1rem;
  padding: 0.5rem;
  text-align: right;
}

.color input {
  border: 0;
  display: block;
  font-family: monospace;
  font-size: 70%;
  margin: 0;
  padding: 0.2rem;
  text-align: right;
  width: 100%;
  color: var(--text-color);
  background: none;
}

</style>
<script>

function hslToHex(hsl) {
  if(hsl.match(/^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/i)) {
    return hsl;
  }
  hsl = hsl.match(/^hsla?\(\s?([-+]?[0-9]*\.?[0-9]*)(?:deg)?,?\s([-+]?[0-9]*\.?[0-9]*)%,?\s([-+]?[0-9]*\.?[0-9]*)%,?\s?(\s+([-+]?[0-9]*\.?[0-9]*))?\)$/i);
  if(!hsl){
    return null;
  }
  let h = hsl[1];
  let s = hsl[2];
  let l = hsl[3];
  h /= 360;
  s /= 100;
  l /= 100;
  let r, g, b;
  if (s === 0) {
    r = g = b = l;
  } else {
    const hue2rgb = function(p, q, t) {
      if (t < 0) t += 1;
      if (t > 1) t -= 1;
      if (t < 1 / 6) return p + (q - p) * 6 * t;
      if (t < 1 / 2) return q;
      if (t < 2 / 3) return p + (q - p) * (2 / 3 - t) * 6;
      return p;
    };
    const q = l < 0.5 ? l * (1 + s) : l + s - l * s;
    const p = 2 * l - q;
    r = hue2rgb(p, q, h + 1 / 3);
    g = hue2rgb(p, q, h);
    b = hue2rgb(p, q, h - 1 / 3);
  }
  const toHex = function(x) {
    const hex = Math.round(x * 255).toString(16);
    return hex.length === 1 ? '0' + hex : hex;
  };
  return '#'+toHex(r)+toHex(g)+toHex(b);
}

function hslCalc(hsl) {
  if (hsl.match(/^hsl?\(\s?[a-z]+?\((\S+\)),\s+[a-z]+?\((\S+\)),\s+[a-z]+?\((.+)\)\)/i)) {
    const style         = getComputedStyle(document.body)
    var   CSSVar        = hsl.match(/var\((\S+)\)/g).map(x => x.replace(')))', ')').match(/var\((\S+)\)/i)[1])
          CSSVar        = CSSVar.map( x => style.getPropertyValue(x.replace(')', '')))
          Operator      = (hsl.match(/ [+|-] /gm) ? hsl.match(/ [+|-] /gm)[0].trim() : '')
          Multiplicator = parseFloat((hsl.match(/(\d+)/gm) ? hsl.match(/(\d+)/gm)[0].trim() : 1))
          Shader        = ((Operator === '+') ? parseFloat(CSSVar[2].slice(0,-1)) + parseFloat(CSSVar[3].slice(0,-1)) : (Operator === '-') ? parseFloat(CSSVar[2].slice(0,-1)) - parseFloat(CSSVar[3].slice(0,-1)) : '')
          Base          = (CSSVar[0].match(/calc/g) ? (parseFloat(CSSVar[0].match(/(\d{1,4})\s+\+\s+(\d{1,4})/i)[1]) + parseFloat(CSSVar[0].match(/(\d{1,4})\s+\+\s+(\d{1,4})/i)[2])): CSSVar[0] )

    if (CSSVar.length == 3) return hslToHex('hsl(' + Base + ',' + CSSVar[1] + ',' + CSSVar[2] + ')')
    if (CSSVar.length == 4) {
      var newhsl = 'hsl('+ Base + ',' + CSSVar[1] + ', ' + (Shader * Multiplicator) + '%)'
      return hslToHex(newhsl)
    }
    return CSSVar
  }
  return hsl
}

// https://codepen.io/tylergaw/pen/jObmNNM

/*
  Check if the stylesheet is internal or hosted on the current domain.
  If it isn't, attempting to access sheet.cssRules will throw a cross origin error.
  See https://developer.mozilla.org/en-US/docs/Web/API/CSSStyleSheet#Notes

  NOTE: One problem this could raise is hosting stylesheets on a CDN with a
  different domain. Those would be cross origin, so you can't access them.
*/
  const isSameDomain = (styleSheet) => {
    // Internal style blocks won't have an href value
    if (!styleSheet.href) {
      return true;
    }
    return styleSheet.href.indexOf(window.location.origin) === 0;
  };
  /*
    Determine if the given rule is a CSSStyleRule
    See: https://developer.mozilla.org/en-US/docs/Web/API/CSSRule#Type_constants
  */
  const isStyleRule = (rule) => rule.type === 1;
  /**
   * Get all custom properties on a page
   * @return array<array[string, string]>
   * ex; [["--color-accent", "#b9f500"], ["--color-text", "#252525"], ...]
   */
  const myMap = new Map();
  const getCSSCustomPropIndex = () =>
    // styleSheets is array-like, so we convert it to an array.
    // Filter out any stylesheets not on this

    [...document.styleSheets].filter(isSameDomain).reduce(
      (finalArr, sheet) =>
      finalArr.concat(
        // cssRules is array-like, so we convert it to an array
        [...sheet.cssRules].filter(isStyleRule).reduce((propValArr, rule) => {
          const props = [...rule.style].reverse()
            .map((propName) => [
              propName.trim(),
              rule.style.getPropertyValue(propName).trim()
            ])
            // Discard any props that don't start with "--". Custom props are required to.
            .filter(([propName]) => propName.indexOf("--color") === 0)
            .map(function(propName) {
              return myMap.set(propName[0],propName[1])
            })
          return [...propValArr, ...props];
        }, [])
      ),
      []
    );
  const cssCustomPropIndex = Array.from(getCSSCustomPropIndex()[0]);
  console.log(cssCustomPropIndex)
  let set = new Set(cssCustomPropIndex.map(JSON.stringify));
  let cssCustomPropIndexFinal = Array.from(set).map(JSON.parse);
  let cssCustomPropIndexPrimary = cssCustomPropIndexFinal.filter(propName => propName[0].includes('primary'))
  let cssCustomPropIndexSecondary = cssCustomPropIndexFinal.filter(propName => propName[0].includes('secondary'))
  let cssCustomPropIndexTertiary = cssCustomPropIndexFinal.filter(propName => propName[0].includes('tertiary'))
  let cssCustomPropIndexGrey = cssCustomPropIndexFinal.filter(propName => propName[0].includes('grey'))

  if (cssCustomPropIndexPrimary.length != 0) {document.querySelector(".primary").classList.remove("hide");document.querySelector(".colortitle").classList.remove("hide")}
  if (cssCustomPropIndexSecondary.length != 0) {document.querySelector(".secondary").classList.remove("hide");document.querySelector(".colortitle").classList.remove("hide")}
  if (cssCustomPropIndexTertiary.length != 0) {document.querySelector(".tertiary").classList.remove("hide");document.querySelector(".colortitle").classList.remove("hide")}
  if (cssCustomPropIndexGrey.length != 0) {document.querySelector(".grey").classList.remove("hide");document.querySelector(".colortitle").classList.remove("hide")}

  // Add the swatches to the DOM
  document.querySelector(".primary ul").innerHTML = cssCustomPropIndexPrimary.reduce(
    (str, [prop, val]) => `${str}<li class="color">
    <b class="color__swatch" style="--color: ${val}"></b>
    <div class="color__details">
      <input value="${prop}" readonly />
      <input value="${hslCalc(val)}" readonly />
    </div>
    </li>`,
    ""
  );

  document.querySelector(".secondary ul").innerHTML = cssCustomPropIndexSecondary.reduce(
    (str, [prop, val]) => `${str}<li class="color">
    <b class="color__swatch" style="--color: ${val}"></b>
    <div class="color__details">
      <input value="${prop}" readonly />
      <input value="${hslCalc(val)}" readonly />
    </div>
    </li>`,
    ""
  );
  document.querySelector(".tertiary ul").innerHTML = cssCustomPropIndexTertiary.reduce(
    (str, [prop, val]) => `${str}<li class="color">
    <b class="color__swatch" style="--color: ${val}"></b>
    <div class="color__details">
      <input value="${prop}" readonly />
      <input value="${val}" readonly />
      <input value="${hslCalc(val)}" readonly />
    </div>
    </li>`,
    ""
  );
  document.querySelector(".grey ul").innerHTML = cssCustomPropIndexGrey.reduce(
    (str, [prop, val]) => `${str}<li class="color">
    <b class="color__swatch" style="--color: ${val}"></b>
    <div class="color__details">
      <input value="${prop}" readonly />
      <input value="${val}" readonly />
    </div>
    </li>`,
    ""
  );

</script>
{{- end -}}
